# Helpers Library

This library implements a number of small, dependency-free utility classes that are too small to constitute their own library. This library will be automatically included when you are using the Digital Lab Gradle plugin - it will only have minimal binary impact since it is fully dependency-free. The library offers a variety of helpers and tools, as described below.

## SmallRye Config Kotlin support
The helpers library contains a few `Interceptor` implementations that aid the use of Kotlin-native features with Smallrye Config. In particular, normally, the use of properties in `@ConfigMapping` interfaces is not supported. This library adds support for it.

This functionality is automatically active once Smallrye Config is present and active in your runtime classpath - for example when you are using Quarkus dependencies or if you manually include Smallrye Config. However, when Smallrye is not present in your classpath, this code is not active and should not interfere with any other code.

### Usage
Usage of these helpers is implicit and automatic. There is no need for manual actions to activate the support. Simply make sure the library as a whole is included (e.g. through the use of the DL Gradle Plugin) and start writing `@ConfigMapping` interfaces with properties and value classes, such as:

```kotlin
@ConfigMapping
interface PathsConfig {
    val rootPath: String
}
```

## NoArgConstructor annotation

This library contains a `NoArgConstructor` annotation that is used to annotate classes that should have a no-argument constructor generated by the Kotlin compiler.

### Prerequisites

If you use the Digital Lab Gradle Plugin the following steps can be skipped as the plugins and configurations are added automatically.

To use the `NoArgConstructor` annotation, you need one of the following Gradle plugins enabled:
- plugin.noarg
- plugin.jpa

The plugin should be configured as follows:

```kotlin
noArg {
    annotation("nl.rug.digitallab.common.kotlin.helpers.noarg.NoArgConstructor")
}
```

### Usage

To use the `NoArgConstructor` annotation, simply annotate your class with it:

```kotlin
@NoArgConstructor
class MyClass {
    // ...
}
```

## ConversionDelegate

This library provides the `ConversionDelegate` and `MutableConversionDelegate` classes, which are simple delegator implementations that allow a property to represent a "computed" view of another property.

On its own, these delegates just form a different way of representing a property with a custom getter and setter. For one-off properties, using a custom getter and setter is easier and clearer. However, this delegate provides a convenient base implementation to be used by helper functions to easily create instances of particular conversions, for example for the `ByteSize` types in the quantities library.

### Usage

By default, these delegates can be used as follows, where `customProperty` and `conversionProperty` function the exact same.

```kotlin
class MyClass(
    var rawValue: String,
) {
    var customProperty: String
        get() = rawValue.reversed()
        set(value) {
            rawValue = value.reversed()
        }
    
    val conversionProperty: String
        by MutableConversionDelegate(MyClass::rawValue, { it.reversed() }, { it.reversed() })
}
```

The more practical use case is to use these delegates to predefine specific conversions. For example:

```kotlin
fun <T> reversal(backingProperty: KProperty1<T, String>)
    = MutableConversionDelegate(backingProperty, { it.reversed() }, { it.reversed() })

class MyClass(
    var rawValue: String,
) {
    var reverseValue: String by reversal(MyClass::rawValue)
}
```

## Ephemeral Utilities

This library provides the `EphemeralDirectory` and `EphemeralFile` classes, which creates temporary directories / files that are deleted upon exit.
To use these, one can create an object of these classes and then invoke the `use` function on them. 

This library also provides `withEphemeralDirectory` and `withEphemeralFile` functions which creates files that are deleted once the scope is left. This
way, you can maintain a relative safe usage of the ephemeral directories / files by restricting your usage to within the scope.

The `EphemeralDirectory`, `EpehemeralFile` classes are `open`, meaning that you can inherit from them.

## Usage

We will demonstrate usage with for ephemeral directories, but ephemeral files are used in an equivalent manner.

```kotlin
// Creates an ephemeral directory
withEphemeralDirectory() {
    // block uses the path to the ephemeral directory
    block(it)
}

// You can optionally provide a "prefix"
withEphemeralDirectory(prefix = "prefix") {
    block(it)
}

// You can optionally provide a parent directory for the ephemeral directory
withEphemeralDirectory(parent = Path("path", "to", "parent")) {
    block(it)
}

// You can optionally provide file attributes for the ephemeral directory
withEphemeralDirectory(prefix, path, *attributes) {
    block(it)
}
```

## Resource Utilities

This helper contains functions related to managing resources for tests, as would reside in `src/test/resources`. The 
`getResource` helpers are used to load resources from the test resources directory. Additional helpers for converting URLs
to files and paths are also provided.

### Usage

`getResource` helpers:

```kotlin
val resourceFromPath = getResource(Path("base", "subpath"))
val resourceFromPathAsStream = getResourceAsStream(Path("base", "subpath"))
val resourceFromString = getResource("base/subpath")
val resourceFromStringAsStream = getResourceAsStream("base/subpath")
```

Conversions:

```kotlin
val resourceAsFile = getResource("base/subpath").asFile()
val resourceAsPath = getResource("base/subpath").asPath()
val file = File("aFile")
getResource("base/subpath").copyToFile(file)
```
